#! /usr/bin/env python3
import codecs
import os, sys, re
import string

  
command_line_args = sys.argv

if (len(command_line_args) != 4) :
  raise AttributeError("Input missing")
  
  # usage /combine_cnf.py in1.cnf in2.cnf out.cnf

inputfile1 = command_line_args[1]
inputfile2 = command_line_args[2]
outputfile1 = command_line_args[3]





f_read = open(inputfile1,"r")
contents = f_read.readlines()

max_clause=contents[-1]
max_clause = max_clause.split(' ')
if len(max_clause) !=2: printf("Last clause is not unit clause")


f_read2 = open(inputfile2,"r")
contents2 = f_read2.readlines()

max_clause2=contents2[-1]
max_clause2 = max_clause2.split(' ')
if len(max_clause2) !=2: printf("Last clause in file 2 is not unit clause")



max_idx = int(max_clause[0]) 
corr_fac = abs(max_idx)
neg_corr_fac = corr_fac*(-1)

print(corr_fac)

max_idx2 = int(max_clause2[0])
if(max_idx2 <0): max_idx2 = max_idx2 + neg_corr_fac
else: max_idx2 = max_idx2 + corr_fac
highest_val = abs(max_idx2)
print(highest_val)

clause_num=len(contents) + len(contents2) - 3 # - 2 header -1 because of clause merch

f_out = open(outputfile1,"w")
f_out.write("p cnf " + str(highest_val) + " " + str(clause_num) + "\n")

for line in contents[1:-1]:
    f_out.write(line)
    



for line in contents2[1:-1]:
  clause = line.split(' ')
  for lit in clause[:-1]:
     var = int(lit)
     if( var <0): var = var + neg_corr_fac
     else: var = var + corr_fac
     f_out.write(str(var)+" ")
  f_out.write("0\n")
  
  
f_out.write(str(max_idx) + " " + str(max_idx2) + " 0\n")




f_read.close()
f_read2.close()
f_out.close()
