#! /usr/bin/env python3
import codecs
import os, sys, re
import string

  
command_line_args = sys.argv

if (len(command_line_args) != 6) :
  raise AttributeError("Input missing")
  
  # usage pxython3 bitproofgen.py btor2.polys btor2.pac out.polys out.pac 2

inputfile1 = command_line_args[1]
inputfile2 = command_line_args[2]
outputfile1 = command_line_args[3]
outputfile2 = command_line_args[4]
n=2*int(command_line_args[5])+3


def bitvec(num,lim=n):
   if not (isinstance(num,int)):
       num=int(num.group(0))
  
   bit='0'+str(lim)+'b'
   res=""
   if(num<0):
     res=" +"
   res=res + str(format(num if num >= 0 else (1 << lim) + num, bit))
   return(res)


f_read = open(inputfile1,"r")
contents = f_read.read()
contents = contents.replace('\\','')
contents = contents.replace(' ','')
contents = contents.replace('\n','')
contents = contents.replace('"','')
contents = contents.replace(';l','; 1*l')
contents = contents.replace(';a','; 1*a')
contents = contents.replace(';s','; 1*s')
contents = contents.replace('-l','-1*l')
contents = contents.replace('-a','-1*a')
contents = contents.replace('-b','-1*b')
contents = contents.replace('-s','-1*s')
contents = contents.replace('+l','+1*l')
contents = contents.replace('+a','+1*a')
contents = contents.replace('+b','+1*b')
contents = contents.replace('+s','+1*s')
contents = contents.replace('-',' -')
contents = contents.replace('+',' +')
contents = contents.replace(';1','; 1')


contents=(re.sub(r'(?<=[\s|\+])-?\d+\.?\d*(?=[\*|\s|,|;])', bitvec, contents)).replace(" ","")
proofs = contents.split(';')


used=[]
f_out = open(outputfile1,"w")

for line in proofs[:-1]:
  if line not in used:
   
    used.append(line)
    f_out.write(line+";\n")




f_read = open(inputfile2,"r")
contents = f_read.read()
contents = contents.replace('\\','')
contents = contents.replace('d','')
contents = contents.replace(' ','')
contents = contents.replace(',a',',1*a')
contents = contents.replace(',l',',1*l')
contents = contents.replace(',b',',1*b')
contents = contents.replace(',s',',1*s')
contents = contents.replace(';l','; 1*l')
contents = contents.replace(';a','; 1*a')
contents = contents.replace(';s','; 1*s')
contents = contents.replace('-l','-1*l')
contents = contents.replace('-a','-1*a')
contents = contents.replace('-b','-1*b')
contents = contents.replace('-s','-1*s')
contents = contents.replace('+l','+1*l')
contents = contents.replace('+a','+1*a')
contents = contents.replace('+b','+1*b')
contents = contents.replace('+s','+1*s')
contents = re.sub(r':1', ':+1', contents)
contents = re.sub(r':2', ':+2', contents)
contents = re.sub(r':3', ':+3', contents)
contents = re.sub(r':4', ':+4', contents)
contents = re.sub(r':5', ':+5', contents)
contents = re.sub(r':6', ':+6', contents)
contents = re.sub(r':7', ':+7', contents)
contents = re.sub(r':8', ':+8', contents)
contents = re.sub(r':9', ':+9', contents)
contents = contents.replace('\n','')
contents = contents.replace('-',' -')
contents = contents.replace(',',', ')
contents = contents.replace('+',' +')
contents = contents.replace(',1;',', 1;')
contents = contents.replace(';1','; 1')
contents = contents.replace(':',',')

contents=(re.sub(r'(?<=[\s|\+])-?\d+\.?\d*(?=[\*|\s|,|;])', bitvec, contents)).replace(" ","")
proofs = contents.split(';')


used=[]
f_out = open(outputfile2,"w")

for line in proofs[:-1]:
  if line not in used:
    mylist = line.split(',')
    for i in range(1,4):
      if(mylist[i][0]=="+"):
        mylist[i]=mylist[i][1:]
    used.append(line)
    f_out.write(mylist[0]+":"+mylist[1]+","+mylist[2]+","+mylist[3]+";\n")



f_out.close()
