#!/bin/sh
path=$1
name=$2
msg () {
  echo "run_13.sh: $*"
}
msg "path:     $path"
msg "name:     $name"
msg "start:    `date`"

rewr=${name}_rewr.aig
miter=${name}_miter.cnf
polys=${name}.polys
pac=${name}.pac
spec=${name}.spec
cnfproof=${name}.proof

# substitution ----------------------------------------------------------

  amulet/amulet -substitute $path $miter $rewr 

# certify aig ------------------------------------------------------

  amulet/amulet -certify $rewr $polys $pac $spec 

# certify cnf ------------------------------------------------------

  cadical --unsat $miter $cnfproof 

# certify cnf ------------------------------------------------------

  pactrim/pactrim $polys $pac $spec 

# certify cnf ------------------------------------------------------

  drat-trim $miter $cnfproof 
msg "end:      `date`"
